Index: uspace/srv/net/il/ip/ip.c
===================================================================
--- uspace/srv/net/il/ip/ip.c	(revision b5cbff48576a057d15deb2e28751ec635d099719)
+++ uspace/srv/net/il/ip/ip.c	(revision 936835e135a18adfccf27258eb51edd1dd5fe962)
@@ -677,135 +687,139 @@
 		// TODO IPv6
 /*		case AF_INET6:
-			if( addrlen != sizeof( struct sockaddr_in6 )) return EINVAL;
-			address_in6 = ( struct sockaddr_in6 * ) dest;
+			if(addrlen != sizeof(struct sockaddr_in6)){
+				return EINVAL;
+			}
+			address_in6 = (struct sockaddr_in6 *) dest;
 			address_in6.sin6_addr.s6_addr;
 			IPV6_LOCALHOST_ADDRESS;
 */		default:
-			return ip_release_and_return( packet, EAFNOSUPPORT );
-	}
-	fibril_rwlock_read_lock( & ip_globals.netifs_lock );
+			return ip_release_and_return(packet, EAFNOSUPPORT);
+	}
+	fibril_rwlock_read_lock(&ip_globals.netifs_lock);
 	// device specified?
-	if( device_id > 0 ){
-		netif = ip_netifs_find( & ip_globals.netifs, device_id );
-		route = ip_netif_find_route( netif, * dest );
-		if( netif && ( ! route ) && ( ip_globals.gateway.netif == netif )){
-			route = & ip_globals.gateway;
+	if(device_id > 0){
+		netif = ip_netifs_find(&ip_globals.netifs, device_id);
+		route = ip_netif_find_route(netif, * dest);
+		if(netif && (! route) && (ip_globals.gateway.netif == netif)){
+			route = &ip_globals.gateway;
 		}
 	}else{
-		route = ip_find_route( * dest );
+		route = ip_find_route(*dest);
 		netif = route ? route->netif : NULL;
 	}
-	if( !( netif && route )){
-		fibril_rwlock_read_unlock( & ip_globals.netifs_lock );
-		phone = ip_prepare_icmp_and_get_phone( error, packet, NULL );
-		if( phone >= 0 ){
+	if(!(netif && route)){
+		fibril_rwlock_read_unlock(&ip_globals.netifs_lock);
+		phone = ip_prepare_icmp_and_get_phone(error, packet, NULL);
+		if(phone >= 0){
 			// unreachable ICMP if no routing
-			icmp_destination_unreachable_msg( phone, ICMP_NET_UNREACH, 0, packet );
+			icmp_destination_unreachable_msg(phone, ICMP_NET_UNREACH, 0, packet);
 		}
 		return ENOENT;
 	}
-	if( error ){
+	if(error){
 		// do not send for broadcast, anycast packets or network broadcast
-		if(( ! dest->s_addr )
-		|| ( !( ~ dest->s_addr ))
-		|| ( !( ~(( dest->s_addr & ( ~ route->netmask.s_addr )) | route->netmask.s_addr )))
-		|| ( !( dest->s_addr & ( ~ route->netmask.s_addr )))){
-			return ip_release_and_return( packet, EINVAL );
-		}
-	}
-	if( route->address.s_addr == dest->s_addr ){
+		if((! dest->s_addr)
+			|| (!(~ dest->s_addr))
+			|| (!(~((dest->s_addr &(~ route->netmask.s_addr)) | route->netmask.s_addr)))
+			|| (!(dest->s_addr &(~ route->netmask.s_addr)))){
+			return ip_release_and_return(packet, EINVAL);
+		}
+	}
+	if(route->address.s_addr == dest->s_addr){
 		// find the loopback device to deliver
 		dest->s_addr = IPV4_LOCALHOST_ADDRESS;
-		route = ip_find_route( * dest );
+		route = ip_find_route(*dest);
 		netif = route ? route->netif : NULL;
-		if( !( netif && route )){
-			fibril_rwlock_read_unlock( & ip_globals.netifs_lock );
-			phone = ip_prepare_icmp_and_get_phone( error, packet, NULL );
-			if( phone >= 0 ){
+		if(!(netif && route)){
+			fibril_rwlock_read_unlock(&ip_globals.netifs_lock);
+			phone = ip_prepare_icmp_and_get_phone(error, packet, NULL);
+			if(phone >= 0){
 				// unreachable ICMP if no routing
-				icmp_destination_unreachable_msg( phone, ICMP_HOST_UNREACH, 0, packet );
+				icmp_destination_unreachable_msg(phone, ICMP_HOST_UNREACH, 0, packet);
 			}
 			return ENOENT;
 		}
 	}
-	src = ip_netif_address( netif );
-	if( ! src ){
-		fibril_rwlock_read_unlock( & ip_globals.netifs_lock );
-		return ip_release_and_return( packet, ENOENT );
-	}
-	ERROR_CODE = ip_send_route( packet, netif, route, src, * dest, error );
-	fibril_rwlock_read_unlock( & ip_globals.netifs_lock );
+	src = ip_netif_address(netif);
+	if(! src){
+		fibril_rwlock_read_unlock(&ip_globals.netifs_lock);
+		return ip_release_and_return(packet, ENOENT);
+	}
+	ERROR_CODE = ip_send_route(packet, netif, route, src, * dest, error);
+	fibril_rwlock_read_unlock(&ip_globals.netifs_lock);
 	return ERROR_CODE;
 }
 
-in_addr_t * ip_netif_address( ip_netif_ref netif ){
-	ip_route_ref	route;
-
-	route = ip_routes_get_index( & netif->routes, 0 );
-	return route ? & route->address : NULL;
-}
-
-int ip_send_route( packet_t packet, ip_netif_ref netif, ip_route_ref route, in_addr_t * src, in_addr_t dest, services_t error ){
+in_addr_t * ip_netif_address(ip_netif_ref netif){
+	ip_route_ref route;
+
+	route = ip_routes_get_index(&netif->routes, 0);
+	return route ? &route->address : NULL;
+}
+
+int ip_send_route(packet_t packet, ip_netif_ref netif, ip_route_ref route, in_addr_t * src, in_addr_t dest, services_t error){
 	ERROR_DECLARE;
 
-	measured_string_t	destination;
-	measured_string_ref	translation;
-	char *				data;
-	int					phone;
+	measured_string_t destination;
+	measured_string_ref translation;
+	char * data;
+	int phone;
 
 	// get destination hardware address
-	if( netif->arp && ( route->address.s_addr != dest.s_addr )){
-		destination.value = route->gateway.s_addr ? ( char * ) & route->gateway.s_addr : ( char * ) & dest.s_addr;
-		destination.length = CONVERT_SIZE( dest.s_addr, char, 1 );
-		if( ERROR_OCCURRED( arp_translate_req( netif->arp->phone, netif->device_id, SERVICE_IP, & destination, & translation, & data ))){
-//			sleep( 1 );
-//			ERROR_PROPAGATE( arp_translate_req( netif->arp->phone, netif->device_id, SERVICE_IP, & destination, & translation, & data ));
-			pq_release( ip_globals.net_phone, packet_get_id( packet ));
+	if(netif->arp && (route->address.s_addr != dest.s_addr)){
+		destination.value = route->gateway.s_addr ? (char *) &route->gateway.s_addr : (char *) &dest.s_addr;
+		destination.length = CONVERT_SIZE(dest.s_addr, char, 1);
+		if(ERROR_OCCURRED(arp_translate_req(netif->arp->phone, netif->device_id, SERVICE_IP, &destination, &translation, &data))){
+//			sleep(1);
+//			ERROR_PROPAGATE(arp_translate_req(netif->arp->phone, netif->device_id, SERVICE_IP, &destination, &translation, &data));
+			pq_release(ip_globals.net_phone, packet_get_id(packet));
 			return ERROR_CODE;
 		}
-		if( !( translation && translation->value )){
-			if( translation ){
-				free( translation );
-				free( data );
-			}
-			phone = ip_prepare_icmp_and_get_phone( error, packet, NULL );
-			if( phone >= 0 ){
+		if(!(translation && translation->value)){
+			if(translation){
+				free(translation);
+				free(data);
+			}
+			phone = ip_prepare_icmp_and_get_phone(error, packet, NULL);
+			if(phone >= 0){
 				// unreachable ICMP if no routing
-				icmp_destination_unreachable_msg( phone, ICMP_HOST_UNREACH, 0, packet );
+				icmp_destination_unreachable_msg(phone, ICMP_HOST_UNREACH, 0, packet);
 			}
 			return EINVAL;
 		}
 	}else translation = NULL;
-	if( ERROR_OCCURRED( ip_prepare_packet( src, dest, packet, translation ))){
-		pq_release( ip_globals.net_phone, packet_get_id( packet ));
+	if(ERROR_OCCURRED(ip_prepare_packet(src, dest, packet, translation))){
+		pq_release(ip_globals.net_phone, packet_get_id(packet));
 	}else{
-		packet = ip_split_packet( packet, netif->packet_dimension.prefix, netif->packet_dimension.content, netif->packet_dimension.suffix, netif->packet_dimension.addr_len, error );
-		if( packet ){
-			nil_send_msg( netif->phone, netif->device_id, packet, SERVICE_IP );
-		}
-	}
-	if( translation ){
-		free( translation );
-		free( data );
+		packet = ip_split_packet(packet, netif->packet_dimension.prefix, netif->packet_dimension.content, netif->packet_dimension.suffix, netif->packet_dimension.addr_len, error);
+		if(packet){
+			nil_send_msg(netif->phone, netif->device_id, packet, SERVICE_IP);
+		}
+	}
+	if(translation){
+		free(translation);
+		free(data);
 	}
 	return ERROR_CODE;
 }
 
-int ip_prepare_packet( in_addr_t * source, in_addr_t dest, packet_t packet, measured_string_ref destination ){
+int ip_prepare_packet(in_addr_t * source, in_addr_t dest, packet_t packet, measured_string_ref destination){
 	ERROR_DECLARE;
 
-	size_t				length;
-	ip_header_ref		header;
-	ip_header_ref		last_header;
-	ip_header_ref		middle_header;
-	packet_t			next;
-
-	length = packet_get_data_length( packet );
-	if(( length < sizeof( ip_header_t )) || ( length > IP_MAX_CONTENT )) return EINVAL;
-	header = ( ip_header_ref ) packet_get_data( packet );
-	if( destination ){
-		ERROR_PROPAGATE( packet_set_addr( packet, NULL, ( uint8_t * ) destination->value, CONVERT_SIZE( char, uint8_t, destination->length )));
+	size_t length;
+	ip_header_ref header;
+	ip_header_ref last_header;
+	ip_header_ref middle_header;
+	packet_t next;
+
+	length = packet_get_data_length(packet);
+	if((length < sizeof(ip_header_t)) || (length > IP_MAX_CONTENT)){
+		return EINVAL;
+	}
+	header = (ip_header_ref) packet_get_data(packet);
+	if(destination){
+		ERROR_PROPAGATE(packet_set_addr(packet, NULL, (uint8_t *) destination->value, CONVERT_SIZE(char, uint8_t, destination->length)));
 	}else{
-		ERROR_PROPAGATE( packet_set_addr( packet, NULL, NULL, 0 ));
+		ERROR_PROPAGATE(packet_set_addr(packet, NULL, NULL, 0));
 	}
 	header->version = IPV4;
@@ -813,157 +827,175 @@
 	header->fragment_offset_low = 0;
 	header->header_checksum = 0;
-	if( source ) header->source_address = source->s_addr;
+	if(source){
+		header->source_address = source->s_addr;
+	}
 	header->destination_address = dest.s_addr;
-	fibril_rwlock_write_lock( & ip_globals.lock );
+	fibril_rwlock_write_lock(&ip_globals.lock);
 	++ ip_globals.packet_counter;
-	header->identification = htons( ip_globals.packet_counter );
-	fibril_rwlock_write_unlock( & ip_globals.lock );
-//	length = packet_get_data_length( packet );
-	if( pq_next( packet )){
-		last_header = ( ip_header_ref ) malloc( IP_HEADER_LENGTH( header ));
-		if( ! last_header ) return ENOMEM;
-		ip_create_last_header( last_header, header );
-		next = pq_next( packet );
-		while( pq_next( next )){
-			middle_header = ( ip_header_ref ) packet_prefix( next, IP_HEADER_LENGTH( last_header ));
-			if( ! middle_header ) return ENOMEM;
-			memcpy( middle_header, last_header, IP_HEADER_LENGTH( last_header ));
+	header->identification = htons(ip_globals.packet_counter);
+	fibril_rwlock_write_unlock(&ip_globals.lock);
+//	length = packet_get_data_length(packet);
+	if(pq_next(packet)){
+		last_header = (ip_header_ref) malloc(IP_HEADER_LENGTH(header));
+		if(! last_header){
+			return ENOMEM;
+		}
+		ip_create_last_header(last_header, header);
+		next = pq_next(packet);
+		while(pq_next(next)){
+			middle_header = (ip_header_ref) packet_prefix(next, IP_HEADER_LENGTH(last_header));
+			if(! middle_header){
+				return ENOMEM;
+			}
+			memcpy(middle_header, last_header, IP_HEADER_LENGTH(last_header));
 			header->flags |= IPFLAG_MORE_FRAGMENTS;
-			middle_header->total_length = htons( packet_get_data_length( next ));
-			middle_header->fragment_offset_high = IP_COMPUTE_FRAGMENT_OFFSET_HIGH( length );
-			middle_header->fragment_offset_low = IP_COMPUTE_FRAGMENT_OFFSET_LOW( length );
-			middle_header->header_checksum = IP_HEADER_CHECKSUM( middle_header );
-			if( destination ){
-				ERROR_PROPAGATE( packet_set_addr( next, NULL, ( uint8_t * ) destination->value, CONVERT_SIZE( char, uint8_t, destination->length )));
-			}
-			length += packet_get_data_length( next );
-			next = pq_next( next );
-		}
-		middle_header = ( ip_header_ref ) packet_prefix( next, IP_HEADER_LENGTH( last_header ));
-		if( ! middle_header ) return ENOMEM;
-		memcpy( middle_header, last_header, IP_HEADER_LENGTH( last_header ));
-		middle_header->total_length = htons( packet_get_data_length( next ));
-		middle_header->fragment_offset_high = IP_COMPUTE_FRAGMENT_OFFSET_HIGH( length );
-		middle_header->fragment_offset_low = IP_COMPUTE_FRAGMENT_OFFSET_LOW( length );
-		middle_header->header_checksum = IP_HEADER_CHECKSUM( middle_header );
-		if( destination ){
-			ERROR_PROPAGATE( packet_set_addr( next, NULL, ( uint8_t * ) destination->value, CONVERT_SIZE( char, uint8_t, destination->length )));
-		}
-		length += packet_get_data_length( next );
-		free( last_header );
+			middle_header->total_length = htons(packet_get_data_length(next));
+			middle_header->fragment_offset_high = IP_COMPUTE_FRAGMENT_OFFSET_HIGH(length);
+			middle_header->fragment_offset_low = IP_COMPUTE_FRAGMENT_OFFSET_LOW(length);
+			middle_header->header_checksum = IP_HEADER_CHECKSUM(middle_header);
+			if(destination){
+				ERROR_PROPAGATE(packet_set_addr(next, NULL, (uint8_t *) destination->value, CONVERT_SIZE(char, uint8_t, destination->length)));
+			}
+			length += packet_get_data_length(next);
+			next = pq_next(next);
+		}
+		middle_header = (ip_header_ref) packet_prefix(next, IP_HEADER_LENGTH(last_header));
+		if(! middle_header){
+			return ENOMEM;
+		}
+		memcpy(middle_header, last_header, IP_HEADER_LENGTH(last_header));
+		middle_header->total_length = htons(packet_get_data_length(next));
+		middle_header->fragment_offset_high = IP_COMPUTE_FRAGMENT_OFFSET_HIGH(length);
+		middle_header->fragment_offset_low = IP_COMPUTE_FRAGMENT_OFFSET_LOW(length);
+		middle_header->header_checksum = IP_HEADER_CHECKSUM(middle_header);
+		if(destination){
+			ERROR_PROPAGATE(packet_set_addr(next, NULL, (uint8_t *) destination->value, CONVERT_SIZE(char, uint8_t, destination->length)));
+		}
+		length += packet_get_data_length(next);
+		free(last_header);
 		header->flags |= IPFLAG_MORE_FRAGMENTS;
 	}
-	header->total_length = htons( length );
+	header->total_length = htons(length);
 	// unnecessary for all protocols
-	header->header_checksum = IP_HEADER_CHECKSUM( header );
+	header->header_checksum = IP_HEADER_CHECKSUM(header);
 	return EOK;
 }
 
-int ip_message( ipc_callid_t callid, ipc_call_t * call, ipc_call_t * answer, int * answer_count ){
+int ip_message(ipc_callid_t callid, ipc_call_t * call, ipc_call_t * answer, int * answer_count){
 	ERROR_DECLARE;
 
-	packet_t				packet;
-	struct sockaddr *		addr;
-	size_t					addrlen;
-	ip_pseudo_header_ref	header;
-	size_t					headerlen;
-
-	* answer_count = 0;
-	switch( IPC_GET_METHOD( * call )){
+	packet_t packet;
+	struct sockaddr * addr;
+	size_t addrlen;
+	ip_pseudo_header_ref header;
+	size_t headerlen;
+
+	*answer_count = 0;
+	switch(IPC_GET_METHOD(*call)){
 		case IPC_M_PHONE_HUNGUP:
 			return EOK;
 		case NET_IL_DEVICE:
-			return ip_device_req( 0, IPC_GET_DEVICE( call ), IPC_GET_SERVICE( call ));
+			return ip_device_req(0, IPC_GET_DEVICE(call), IPC_GET_SERVICE(call));
 		case IPC_M_CONNECT_TO_ME:
-			return ip_register( IL_GET_PROTO( call ), IL_GET_SERVICE( call ), IPC_GET_PHONE( call ), NULL );
+			return ip_register(IL_GET_PROTO(call), IL_GET_SERVICE(call), IPC_GET_PHONE(call), NULL);
 		case NET_IL_SEND:
-			ERROR_PROPAGATE( packet_translate( ip_globals.net_phone, & packet, IPC_GET_PACKET( call )));
-			return ip_send_msg( 0, IPC_GET_DEVICE( call ), packet, 0, IPC_GET_ERROR( call ));
+			ERROR_PROPAGATE(packet_translate(ip_globals.net_phone, &packet, IPC_GET_PACKET(call)));
+			return ip_send_msg(0, IPC_GET_DEVICE(call), packet, 0, IPC_GET_ERROR(call));
 		case NET_IL_DEVICE_STATE:
-			return ip_device_state_message( IPC_GET_DEVICE( call ), IPC_GET_STATE( call ));
+			return ip_device_state_message(IPC_GET_DEVICE(call), IPC_GET_STATE(call));
 		case NET_IL_RECEIVED:
-			ERROR_PROPAGATE( packet_translate( ip_globals.net_phone, & packet, IPC_GET_PACKET( call )));
-			return ip_receive_message( IPC_GET_DEVICE( call ), packet );
+			ERROR_PROPAGATE(packet_translate(ip_globals.net_phone, &packet, IPC_GET_PACKET(call)));
+			return ip_receive_message(IPC_GET_DEVICE(call), packet);
 		case NET_IP_RECEIVED_ERROR:
-			ERROR_PROPAGATE( packet_translate( ip_globals.net_phone, & packet, IPC_GET_PACKET( call )));
-			return ip_received_error_msg( 0, IPC_GET_DEVICE( call ), packet, IPC_GET_TARGET( call ), IPC_GET_ERROR( call ));
+			ERROR_PROPAGATE(packet_translate(ip_globals.net_phone, &packet, IPC_GET_PACKET(call)));
+			return ip_received_error_msg(0, IPC_GET_DEVICE(call), packet, IPC_GET_TARGET(call), IPC_GET_ERROR(call));
 		case NET_IP_ADD_ROUTE:
-			return ip_add_route_req( 0, IPC_GET_DEVICE( call ), IP_GET_ADDRESS( call ), IP_GET_NETMASK( call ), IP_GET_GATEWAY( call ));
+			return ip_add_route_req(0, IPC_GET_DEVICE(call), IP_GET_ADDRESS(call), IP_GET_NETMASK(call), IP_GET_GATEWAY(call));
 		case NET_IP_SET_GATEWAY:
-			return ip_set_gateway_req( 0, IPC_GET_DEVICE( call ), IP_GET_GATEWAY( call ));
+			return ip_set_gateway_req(0, IPC_GET_DEVICE(call), IP_GET_GATEWAY(call));
 		case NET_IP_GET_ROUTE:
-			ERROR_PROPAGATE( data_receive(( void ** ) & addr, & addrlen ));
-			ERROR_PROPAGATE( ip_get_route_req( 0, IP_GET_PROTOCOL( call ), addr, ( socklen_t ) addrlen, IPC_SET_DEVICE( answer ), & header, & headerlen ));
-			* IP_SET_HEADERLEN( answer ) = headerlen;
-			* answer_count = 2;
-			if( ! ERROR_OCCURRED( data_reply( & headerlen, sizeof( headerlen )))){
-				ERROR_CODE = data_reply( header, headerlen );
-			}
-			free( header );
+			ERROR_PROPAGATE(data_receive((void **) &addr, &addrlen));
+			ERROR_PROPAGATE(ip_get_route_req(0, IP_GET_PROTOCOL(call), addr, (socklen_t) addrlen, IPC_SET_DEVICE(answer), &header, &headerlen));
+			*IP_SET_HEADERLEN(answer) = headerlen;
+			*answer_count = 2;
+			if(! ERROR_OCCURRED(data_reply(&headerlen, sizeof(headerlen)))){
+				ERROR_CODE = data_reply(header, headerlen);
+			}
+			free(header);
 			return ERROR_CODE;
 		case NET_IL_PACKET_SPACE:
-			ERROR_PROPAGATE( ip_packet_size_message( IPC_GET_DEVICE( call ), IPC_SET_ADDR( answer ), IPC_SET_PREFIX( answer ), IPC_SET_CONTENT( answer ), IPC_SET_SUFFIX( answer )));
-			* answer_count = 3;
+			ERROR_PROPAGATE(ip_packet_size_message(IPC_GET_DEVICE(call), IPC_SET_ADDR(answer), IPC_SET_PREFIX(answer), IPC_SET_CONTENT(answer), IPC_SET_SUFFIX(answer)));
+			*answer_count = 3;
 			return EOK;
 		case NET_IL_MTU_CHANGED:
-			return ip_mtu_changed_message( IPC_GET_DEVICE( call ), IPC_GET_MTU( call ));
+			return ip_mtu_changed_message(IPC_GET_DEVICE(call), IPC_GET_MTU(call));
 	}
 	return ENOTSUP;
 }
 
-int ip_packet_size_req( int ip_phone, device_id_t device_id, packet_dimension_ref packet_dimension ){
-	if( ! packet_dimension ) return EBADMEM;
-	return ip_packet_size_message( device_id, & packet_dimension->addr_len, & packet_dimension->prefix, & packet_dimension->content, & packet_dimension->suffix );
-}
-
-int ip_packet_size_message( device_id_t device_id, size_t * addr_len, size_t * prefix, size_t * content, size_t * suffix ){
-	ip_netif_ref	netif;
-	int				index;
-
-	if( !( addr_len && prefix && content && suffix )) return EBADMEM;
-	* content = IP_MAX_CONTENT - IP_PREFIX;
-	fibril_rwlock_read_lock( & ip_globals.netifs_lock );
-	if( device_id < 0 ){
-		* addr_len = IP_ADDR;
-		* prefix = 0;
-		* suffix = 0;
-		for( index = ip_netifs_count( & ip_globals.netifs ) - 1; index >= 0; -- index ){
-			netif = ip_netifs_get_index( & ip_globals.netifs, index );
-			if( netif ){
-				if( netif->packet_dimension.addr_len > * addr_len ) * addr_len = netif->packet_dimension.addr_len;
-				if( netif->packet_dimension.prefix > * prefix ) * prefix = netif->packet_dimension.prefix;
-				if( netif->packet_dimension.suffix > * suffix ) * suffix = netif->packet_dimension.suffix;
-			}
-		}
-		* prefix = * prefix + IP_PREFIX;
-		* suffix = * suffix + IP_SUFFIX;
+int ip_packet_size_req(int ip_phone, device_id_t device_id, packet_dimension_ref packet_dimension){
+	if(! packet_dimension){
+		return EBADMEM;
+	}
+	return ip_packet_size_message(device_id, &packet_dimension->addr_len, &packet_dimension->prefix, &packet_dimension->content, &packet_dimension->suffix);
+}
+
+int ip_packet_size_message(device_id_t device_id, size_t * addr_len, size_t * prefix, size_t * content, size_t * suffix){
+	ip_netif_ref netif;
+	int index;
+
+	if(!(addr_len && prefix && content && suffix)){
+		return EBADMEM;
+	}
+	*content = IP_MAX_CONTENT - IP_PREFIX;
+	fibril_rwlock_read_lock(&ip_globals.netifs_lock);
+	if(device_id < 0){
+		*addr_len = IP_ADDR;
+		*prefix = 0;
+		*suffix = 0;
+		for(index = ip_netifs_count(&ip_globals.netifs) - 1; index >= 0; -- index){
+			netif = ip_netifs_get_index(&ip_globals.netifs, index);
+			if(netif){
+				if(netif->packet_dimension.addr_len > * addr_len){
+					*addr_len = netif->packet_dimension.addr_len;
+				}
+				if(netif->packet_dimension.prefix > * prefix){
+					*prefix = netif->packet_dimension.prefix;
+				}
+				if(netif->packet_dimension.suffix > * suffix){
+					*suffix = netif->packet_dimension.suffix;
+				}
+			}
+		}
+		*prefix = * prefix + IP_PREFIX;
+		*suffix = * suffix + IP_SUFFIX;
 	}else{
-		netif = ip_netifs_find( & ip_globals.netifs, device_id );
-		if( ! netif ){
-			fibril_rwlock_read_unlock( & ip_globals.netifs_lock );
+		netif = ip_netifs_find(&ip_globals.netifs, device_id);
+		if(! netif){
+			fibril_rwlock_read_unlock(&ip_globals.netifs_lock);
 			return ENOENT;
 		}
-		* addr_len = ( netif->packet_dimension.addr_len > IP_ADDR ) ? netif->packet_dimension.addr_len : IP_ADDR;
-		* prefix = netif->packet_dimension.prefix + IP_PREFIX;
-		* suffix = netif->packet_dimension.suffix + IP_SUFFIX;
-	}
-	fibril_rwlock_read_unlock( & ip_globals.netifs_lock );
+		*addr_len = (netif->packet_dimension.addr_len > IP_ADDR) ? netif->packet_dimension.addr_len : IP_ADDR;
+		*prefix = netif->packet_dimension.prefix + IP_PREFIX;
+		*suffix = netif->packet_dimension.suffix + IP_SUFFIX;
+	}
+	fibril_rwlock_read_unlock(&ip_globals.netifs_lock);
 	return EOK;
 }
 
-int ip_add_route_req( int ip_phone, device_id_t device_id, in_addr_t address, in_addr_t netmask, in_addr_t gateway ){
-	ip_route_ref	route;
-	ip_netif_ref	netif;
-	int				index;
-
-	fibril_rwlock_write_lock( & ip_globals.netifs_lock );
-	netif = ip_netifs_find( & ip_globals.netifs, device_id );
-	if( ! netif ){
-		fibril_rwlock_write_unlock( & ip_globals.netifs_lock );
+int ip_add_route_req(int ip_phone, device_id_t device_id, in_addr_t address, in_addr_t netmask, in_addr_t gateway){
+	ip_route_ref route;
+	ip_netif_ref netif;
+	int index;
+
+	fibril_rwlock_write_lock(&ip_globals.netifs_lock);
+	netif = ip_netifs_find(&ip_globals.netifs, device_id);
+	if(! netif){
+		fibril_rwlock_write_unlock(&ip_globals.netifs_lock);
 		return ENOENT;
 	}
-	route = ( ip_route_ref ) malloc( sizeof( ip_route_t ));
-	if( ! route ){
-		fibril_rwlock_write_unlock( & ip_globals.netifs_lock );
+	route = (ip_route_ref) malloc(sizeof(ip_route_t));
+	if(! route){
+		fibril_rwlock_write_unlock(&ip_globals.netifs_lock);
 		return ENOMEM;
 	}
@@ -972,37 +1004,41 @@
 	route->gateway.s_addr = gateway.s_addr;
 	route->netif = netif;
-	index = ip_routes_add( & netif->routes, route );
-	if( index < 0 ) free( route );
-	fibril_rwlock_write_unlock( & ip_globals.netifs_lock );
+	index = ip_routes_add(&netif->routes, route);
+	if(index < 0){
+		free(route);
+	}
+	fibril_rwlock_write_unlock(&ip_globals.netifs_lock);
 	return index;
 }
 
-ip_route_ref ip_find_route( in_addr_t destination ){
-	int				index;
-	ip_route_ref	route;
-	ip_netif_ref	netif;
+ip_route_ref ip_find_route(in_addr_t destination){
+	int index;
+	ip_route_ref route;
+	ip_netif_ref netif;
 
 	// start with the last netif - the newest one
-	index = ip_netifs_count( & ip_globals.netifs ) - 1;
-	while( index >= 0 ){
-		netif = ip_netifs_get_index( & ip_globals.netifs, index );
-		if( netif && ( netif->state == NETIF_ACTIVE )){
-			route = ip_netif_find_route( netif, destination );
-			if( route ) return route;
+	index = ip_netifs_count(&ip_globals.netifs) - 1;
+	while(index >= 0){
+		netif = ip_netifs_get_index(&ip_globals.netifs, index);
+		if(netif && (netif->state == NETIF_ACTIVE)){
+			route = ip_netif_find_route(netif, destination);
+			if(route){
+				return route;
+			}
 		}
 		-- index;
 	}
-	return & ip_globals.gateway;
-}
-
-ip_route_ref ip_netif_find_route( ip_netif_ref netif, in_addr_t destination ){
-	int				index;
-	ip_route_ref	route;
-
-	if( netif ){
+	return &ip_globals.gateway;
+}
+
+ip_route_ref ip_netif_find_route(ip_netif_ref netif, in_addr_t destination){
+	int index;
+	ip_route_ref route;
+
+	if(netif){
 		// start with the first one - the direct route
-		for( index = 0; index < ip_routes_count( & netif->routes ); ++ index ){
-			route = ip_routes_get_index( & netif->routes, index );
-			if( route && (( route->address.s_addr & route->netmask.s_addr ) == ( destination.s_addr & route->netmask.s_addr ))){
+		for(index = 0; index < ip_routes_count(&netif->routes); ++ index){
+			route = ip_routes_get_index(&netif->routes, index);
+			if(route && ((route->address.s_addr &route->netmask.s_addr) == (destination.s_addr &route->netmask.s_addr))){
 				return route;
 			}
@@ -1012,11 +1048,11 @@
 }
 
-int ip_set_gateway_req( int ip_phone, device_id_t device_id, in_addr_t gateway ){
-	ip_netif_ref	netif;
-
-	fibril_rwlock_write_lock( & ip_globals.netifs_lock );
-	netif = ip_netifs_find( & ip_globals.netifs, device_id );
-	if( ! netif ){
-		fibril_rwlock_write_unlock( & ip_globals.netifs_lock );
+int ip_set_gateway_req(int ip_phone, device_id_t device_id, in_addr_t gateway){
+	ip_netif_ref netif;
+
+	fibril_rwlock_write_lock(&ip_globals.netifs_lock);
+	netif = ip_netifs_find(&ip_globals.netifs, device_id);
+	if(! netif){
+		fibril_rwlock_write_unlock(&ip_globals.netifs_lock);
 		return ENOENT;
 	}
@@ -1025,37 +1061,37 @@
 	ip_globals.gateway.gateway.s_addr = gateway.s_addr;
 	ip_globals.gateway.netif = netif;
-	fibril_rwlock_write_unlock( & ip_globals.netifs_lock );
+	fibril_rwlock_write_unlock(&ip_globals.netifs_lock);
 	return EOK;
 }
 
-packet_t ip_split_packet( packet_t packet, size_t prefix, size_t content, size_t suffix, socklen_t addr_len, services_t error ){
-	size_t			length;
-	packet_t		next;
-	packet_t		new_packet;
-	int				result;
-	int				phone;
+packet_t ip_split_packet(packet_t packet, size_t prefix, size_t content, size_t suffix, socklen_t addr_len, services_t error){
+	size_t length;
+	packet_t next;
+	packet_t new_packet;
+	int result;
+	int phone;
 
 	next = packet;
 	// check all packets
-	while( next ){
-		length = packet_get_data_length( next );
+	while(next){
+		length = packet_get_data_length(next);
 		// too long?
-		if( length > content ){
-			result = ip_fragment_packet( next, content, prefix, suffix, addr_len );
-			if( result != EOK ){
-				new_packet = pq_detach( next );
-				if( next == packet ){
+		if(length > content){
+			result = ip_fragment_packet(next, content, prefix, suffix, addr_len);
+			if(result != EOK){
+				new_packet = pq_detach(next);
+				if(next == packet){
 					// the new first packet of the queue
 					packet = new_packet;
 				}
 				// fragmentation needed?
-				if( result == EPERM ){
-					phone = ip_prepare_icmp_and_get_phone( error, next, NULL );
-					if( phone >= 0 ){
+				if(result == EPERM){
+					phone = ip_prepare_icmp_and_get_phone(error, next, NULL);
+					if(phone >= 0){
 						// fragmentation necessary ICMP
-						icmp_destination_unreachable_msg( phone, ICMP_FRAG_NEEDED, content, next );
+						icmp_destination_unreachable_msg(phone, ICMP_FRAG_NEEDED, content, next);
 					}
 				}else{
-					pq_release( ip_globals.net_phone, packet_get_id( next ));
+					pq_release(ip_globals.net_phone, packet_get_id(next));
 				}
 				next = new_packet;
